{{ ansible_managed | comment }}

# HTTPS server
#
server {
{% if ansible_distribution_release == 'xenial' %}
# https://bugs.launchpad.net/ubuntu/+source/nginx/+bug/1552949
    # Nginx >= 1.9.5
    listen {{ harden_nginx_https_port | default('443') }} ssl;
    listen [::]:{{ harden_nginx_https_port | default('443') }} ssl;
{% else %}
    # Nginx >= 1.9.5
    listen {{ harden_nginx_https_port | default('443') }} ssl http2;
    listen [::]:{{ harden_nginx_https_port | default('443') }} ssl http2;
{% endif %}

    server_name localhost;
    server_tokens off;
    etag off;

    root {{ hardenwebserver_rootdir | default(_hardenwebserver_rootdir) }};
    index index.html index.htm;

    include /etc/nginx/harden-nginx-https;
{% if hardenwebserver_cert is defined and hardenwebserver_cert == 'selfsigned' %}
    ssl_certificate {{ hardenwebserver_ssl_cert | default( ssl_dir + "/" + ansible_fqdn + ".crt") }};
{% else %}
    ssl_certificate {{ hardenwebserver_ssl_cert | default( ssl_dir + "/" + ansible_fqdn + "-fullchain.crt") }};
{% endif %}
    ssl_certificate_key {{ hardenwebserver_ssl_key | default( ssl_privatedir + "/" + ansible_fqdn + ".key") }};

    add_header Strict-Transport-Security "max-age=63072000; includeSubdomains; preload";
    add_header X-Frame-Options SAMEORIGIN;
    add_header X-Content-Type-Options nosniff;
    # want to be indexed by search engine?
    add_header X-Robots-Tag none;

## sensitive get/no logging: http://stackoverflow.com/questions/19265766/how-to-not-log-a-get-request-parameter-in-the-nginx-access-logs

    keepalive_timeout   70;

    include /etc/nginx/harden-nginx-common;
{% if hardenwebserver_nginx_debian_pkg == 'nginx-full' and ansible_distribution == 'Debian' and false %}
    include /etc/nginx/harden-nginx-limit_req;
{% endif %}

    # https://www.bjornjohansen.com/restrict-allowed-http-methods-in-nginx
    error_page 405 @error405;
    location @error405 {
        add_header Allow "GET, POST, HEAD" always;
    }

{% if hardennginx_https_rootlocation %}
    location / {
        root {{ hardenwebserver_rootdir | default(_hardenwebserver_rootdir) }};
{% if hardenwebserver_nginx_debian_pkg is defined and hardenwebserver_nginx_debian_pkg == 'nginx-naxsi' and hardenwebserver_nginx_naxsi is defined and hardenwebserver_nginx_naxsi %}
            include /etc/nginx/naxsi.rules;
{% endif %}
{% if hardenwebserver_nginx_with_fastcgi is defined and hardenwebserver_nginx_with_fastcgi %}
#            include /etc/nginx/harden-nginx-fastcgi_params;
{% endif %}

        }

{% endif %}
{% for f in hardenwebserver_nginx_https_server_include %}
    include /etc/nginx/{{ f.name }}{{ nginx_conf_suffix }};
{% endfor %}

}
